
QGIS Application - Bug report #15600

Selecting features feature in spatial views and virtual layers leads to wrong results

2016-09-21 02:15 PM - Gerhard Spieles

Status: Open

Priority: High

Assignee: Hugo Mercier

Category: Vectors

Affected QGIS version:3.5(master) Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23523

Description

Select features in spatialite views higlights wrong objects

Related issues:

Related to QGIS Application - Bug report # 14232: select features in a spatia... Closed 2016-02-04

Related to QGIS Application - Bug report # 15709: bad match of valeurs with v... Closed 2016-10-14

Related to QGIS Application - Bug report # 18973: Wrong identification of fea... Open 2018-05-17

History

#1 - 2016-09-21 11:57 PM - R. R.

See also: #15134 (Virtual Layer - Selecting multipart features fails)

Perhaps these issues are related, since virtual layers are based on SpatiaLite.

#2 - 2017-05-01 01:03 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#3 - 2017-10-01 09:39 AM - Giovanni Manghi

- Regression? changed from No to Yes

- Priority changed from Normal to High

- Affected QGIS version changed from 2.14.5 to 2.18.13

Worked as expected for SL views (virtual layer untested as they were not available) until 2.8.*

#4 - 2017-10-01 09:51 AM - Giovanni Manghi

- Subject changed from Select feature in spatial views leads to wrong results to Selecting features feature in spatial views and virtual layers leads to 

wrong results

#5 - 2017-10-04 04:56 PM - Vincent Dionne

The same problem is present in 2.18.13 when adding a spatialite layer through DB MANAGER -SQL Query.

Easy to replicate: DB Manager => SQLITE => SQL window => Select * from your_layer => add layer.

Feature selection will be wrong.
#6 - 2017-10-10 08:42 AM - Jürgen Fischer

- Related to Bug report #14232: select features in a spatialite view leads to wrong_results added

#7 - 2018-01-27 09:45 AM - Jürgen Fischer

- Related to Bug report #15709: bad match of valeurs with virtual layer added

#8 - 2018-02-26 09:52 PM - Gerhard Spieles

Issue is still present in 3.1.0-3 (see Mail Paolo Cavallini, QGIS tickets)

#9 - 2018-03-03 09:35 PM - Giovanni Manghi

- Affected QGIS version changed from 2.18.13 to 3.1(master)

- Operating System deleted (win)

#10 - 2018-04-25 03:31 PM - Leon van der Meulen

Problem still persists in 3 as well with PostGIS layers. Ordinary file based layers are ok though

#11 - 2018-06-04 10:08 AM - Dominique Lyszczarz

Confirmed with a Geopackage spatial view. Note it also affect manual label positioning with xy position stored in auxiliary layer : trying to move a label with

the dedicated tool performs the shift for another feature's label.

#12 - 2018-10-24 10:46 AM - Hugo Mercier

- Related to Bug report #18973: Wrong identification of feature in a View added

#13 - 2018-10-24 10:58 AM - Hugo Mercier

- Assignee set to Hugo Mercier

I see several issues in the provided project:

- virtual layers: selection works fine, but the identification tool identifies all the object

- spatialite views: selection selects the wrong feature, identification tool seems ok

#14 - 2018-12-28 12:25 PM - Paolo Cavallini

Could you please check again on current release and update the affected version if still valid?

Thanks.

#15 - 2018-12-28 02:52 PM - Giovanni Manghi

- Status changed from Open to Feedback

Paolo Cavallini wrote:

Could you please check again on current release and update the affected version if still valid?

Thanks.
Please change status to "feedback" when needed.

#16 - 2019-01-01 04:35 PM - Gerhard Spieles

- Affected QGIS version changed from 3.1(master) to 3.5(master)

- File testviewspatialite_qgis3_5_56.zip added

Hello,

tested issue with 3.5master, Rel 56.

To exclude faults, i have created a complete new project in 3.5 with a newly created spatialite database and layers via QGIS. Testproject and database are

attached (zip).

Virtual Layers seems to be ok!.

Spatialite views leads to the same wrong results in selecting objects.

The issue seems for me to depend in the interpretation/handling of the "ROWID" in QGIS.

In the sample data, I created to views. One with the "ROWID" from the geometrielayer(Parent), one without.

The layer (view) with the "ROWID" shows:

-undefined selection behaviour for objects

-in objectcount = 0,

-open the the attribute table, 100 filtered Rows are shown. Really, the layer has 256 rows.

-When you go to the layer in the layers panel, right click, filter and define a filter "ROWID < 1000000", the objectcount shows 256 rows and the attrubute

table shows all the 256 rows. Selecton behaviour is further undefined.

The layer (view) without "ROWID" shows:

-all objects are selected, even only one oject was clicked.

-in objectcount 0

-in attribute table only one filtered row. Setting a filter via layers panel like "ROWID < 1000000" brings no change.

#17 - 2019-01-01 05:24 PM - Giovanni Manghi

- Status changed from Feedback to Open

Files

test.zip 464 KB 2016-09-21 Gerhard Spieles

testviewspatialite_qgis3_5_56.zip 441 KB 2019-01-01 Gerhard Spieles
